<?php
/*
 * Ipblock Action Plugin.
 *
 * @license  Apache License, Version 2.0 (http://www.apache.org/licenses/LICENSE-2.0)
 * @author   Kazuyuki Matsuda <kazm@shorindo.com>
 */

class action_plugin_ipblock extends DokuWiki_Action_Plugin {

	function getInfo() {
        return confToHash(dirname(__FILE__).'/plugin.info.txt');
	}

	function register(&$controller) {
        global $ACT, $ID;

        $controller->register_hook('ACTION_ACT_PREPROCESS',
                                   'BEFORE', $this, 'filter');
	}

    function filter(&$event) {
        global $conf;

        if (!$this->is_clean()) {
            $disabled = explode(',', $conf['disableactions']);
            $acts = explode(',', $this->getConf('actions'));

            foreach ($acts as $act) {
                if (!in_array($act, $disabled)) {
                    $disabled[] = $act;
                }
            }
            $conf['disableactions'] = implode(',', $disabled);
        }

        return true;
    }

    /**
     * whitelist -> blacklist の順に評価する。
     * blackならばtrueを返す。
     */
    function is_clean() {
        $client = clientIP(true);
        $whitelist = explode(' ', $this->getConf('whitelist'));
        foreach ($whitelist as $white) {
            //dbglog("is_clean({$client} <=> {$white}");
            if ($white && strpos($client, $white) === 0) {
                return true;
            }
        }
        return false;
    }
}
